<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlanningInterfaceResult_v4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlanningInterfaceResult_v4 extends AbstractStructArrayBase
{
    /**
     * The PlanningInterfaceResult_v4
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlanningInterfaceResult_v4[]
     */
    public $PlanningInterfaceResult_v4;
    /**
     * Constructor method for ArrayOfPlanningInterfaceResult_v4
     * @uses ArrayOfPlanningInterfaceResult_v4::setPlanningInterfaceResult_v4()
     * @param \StructType\PlanningInterfaceResult_v4[] $planningInterfaceResult_v4
     */
    public function __construct(array $planningInterfaceResult_v4 = array())
    {
        $this
            ->setPlanningInterfaceResult_v4($planningInterfaceResult_v4);
    }
    /**
     * Get PlanningInterfaceResult_v4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlanningInterfaceResult_v4[]|null
     */
    public function getPlanningInterfaceResult_v4()
    {
        return isset($this->PlanningInterfaceResult_v4) ? $this->PlanningInterfaceResult_v4 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlanningInterfaceResult_v4 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlanningInterfaceResult_v4 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlanningInterfaceResult_v4ForArrayConstraintsFromSetPlanningInterfaceResult_v4(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlanningInterfaceResult_v4PlanningInterfaceResult_v4Item) {
            // validation for constraint: itemType
            if (!$arrayOfPlanningInterfaceResult_v4PlanningInterfaceResult_v4Item instanceof \StructType\PlanningInterfaceResult_v4) {
                $invalidValues[] = is_object($arrayOfPlanningInterfaceResult_v4PlanningInterfaceResult_v4Item) ? get_class($arrayOfPlanningInterfaceResult_v4PlanningInterfaceResult_v4Item) : sprintf('%s(%s)', gettype($arrayOfPlanningInterfaceResult_v4PlanningInterfaceResult_v4Item), var_export($arrayOfPlanningInterfaceResult_v4PlanningInterfaceResult_v4Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlanningInterfaceResult_v4 property can only contain items of type \StructType\PlanningInterfaceResult_v4, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlanningInterfaceResult_v4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningInterfaceResult_v4[] $planningInterfaceResult_v4
     * @return \ArrayType\ArrayOfPlanningInterfaceResult_v4
     */
    public function setPlanningInterfaceResult_v4(array $planningInterfaceResult_v4 = array())
    {
        // validation for constraint: array
        if ('' !== ($planningInterfaceResult_v4ArrayErrorMessage = self::validatePlanningInterfaceResult_v4ForArrayConstraintsFromSetPlanningInterfaceResult_v4($planningInterfaceResult_v4))) {
            throw new \InvalidArgumentException($planningInterfaceResult_v4ArrayErrorMessage, __LINE__);
        }
        if (is_null($planningInterfaceResult_v4) || (is_array($planningInterfaceResult_v4) && empty($planningInterfaceResult_v4))) {
            unset($this->PlanningInterfaceResult_v4);
        } else {
            $this->PlanningInterfaceResult_v4 = $planningInterfaceResult_v4;
        }
        return $this;
    }
    /**
     * Add item to PlanningInterfaceResult_v4 value
     * @throws \InvalidArgumentException
     * @param \StructType\PlanningInterfaceResult_v4 $item
     * @return \ArrayType\ArrayOfPlanningInterfaceResult_v4
     */
    public function addToPlanningInterfaceResult_v4(\StructType\PlanningInterfaceResult_v4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlanningInterfaceResult_v4) {
            throw new \InvalidArgumentException(sprintf('The PlanningInterfaceResult_v4 property can only contain items of type \StructType\PlanningInterfaceResult_v4, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlanningInterfaceResult_v4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlanningInterfaceResult_v4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlanningInterfaceResult_v4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlanningInterfaceResult_v4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlanningInterfaceResult_v4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlanningInterfaceResult_v4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlanningInterfaceResult_v4
     */
    public function getAttributeName()
    {
        return 'PlanningInterfaceResult_v4';
    }
}
